defmodule DecentralisedBookIndex.Sync.ApiClients.FetchJsons do
  alias DecentralisedBookIndex.Sync.ApiClients.FetchJsons
  alias DecentralisedBookIndex.Sync.ApiClients.FetchJson

  require Logger

  def get(url, mapper \\ &FetchJsons.get_data/1) do
    query_results =
      Stream.resource(
        # Initial state:
        fn -> url end,
        fn
          # Stop the stream if no more data
          next when is_nil(next) ->
            {:halt, nil}

          next ->
            case FetchJson.get(next) do
              {:ok, page} ->
                {mapper.(page["data"]), get_in(page, ["links", "next"])}
              {:error, message} ->
                Logger.error("FetchJsons error for #{url}: #{inspect(message)}")
                {[], nil}
            end
        end,
        fn _ -> :ok end
      )
      |> Enum.to_list()

    {:ok, query_results}
  end

  def get_data(data) do
    data
  end
end
