defmodule DecentralisedBookIndex.Sync.SyncServerTaskTest do
  use DecentralisedBookIndex.DataCase

  alias DecentralisedBookIndex.Sync.SyncServerTask

  alias DecentralisedBookIndex.Sync.ApiClients.FetchJson
  alias DecentralisedBookIndex.Sync.AuthorSync

  alias DecentralisedBookIndex.Metadata

  alias DecentralisedBookIndex.TestEndpoints
  @test_server_endpoint TestEndpoints.test_api_endpoint()

  setup do
    user = generate(user(role: :moderator))
    %{user: user}
  end

  describe "sync all" do
    test "servers", %{user: user} do
      server = generate(dbi_server(url: @test_server_endpoint))
      {:ok, author} = Metadata.create_author("Author", "An description", nil, nil, actor: user)

      assert server = SyncServerTask.sync_all()
    end
  end

  describe "sync one" do
    test "server", %{user: user} do
      server = generate(dbi_server(url: @test_server_endpoint))
      {:ok, author} = Metadata.create_author("Author", "An description", nil, nil, actor: user)

      assert server = SyncServerTask.sync_one(server)
    end
  end
end
